package org.dataone.audit.server;
import java.text.DateFormat;
import java.util.Date;

import org.dataone.client.CNode;
import org.dataone.service.exceptions.InvalidRequest;
import org.dataone.service.exceptions.InvalidToken;
import org.dataone.service.exceptions.NotAuthorized;
import org.dataone.service.exceptions.NotImplemented;
import org.dataone.service.exceptions.ServiceFailure;
import org.dataone.service.types.v1.ObjectInfo;
import org.dataone.service.types.v1.ObjectList;


class ReadObjectsFromCNode implements Runnable 
{
	/* Instance variables */
	final protected CNode cnode;
	
	
	ReadObjectsFromCNode(CNode cnode) 
	{
		this.cnode = cnode;
	}
	
	public void run() 
	{
		System.out.printf("In run: Node url = %s\n", cnode.getNodeBaseServiceUrl());
		
		try 
		{
			/* Unix Epoch */
			Date fromDate = new Date(0);
			
			int count = 1024;
			
			while(fromDate != null)
			{
				
				//cnode.listObjects(fromDate, toDate, formatid, replicaStatus, start, count)
			
				/* Get the next page of the objects */
				ObjectList objectList = cnode.listObjects(fromDate, null, null, null, null, count);
			
				Date newFromDate = null;
				
				for(ObjectInfo objectInfo : objectList.getObjectInfoList())
				{
					newFromDate = objectInfo.getDateSysMetadataModified();
				}
				
				System.out.println(newFromDate);
				
				
				/* Finished */
				if(objectList.getCount() < count)
				{
					fromDate = null;
					
				/* Data is equal so increase the count and scan again */
				}else if(fromDate.equals(newFromDate))
				{
					count *= 2;
					
				/* Set the count to 1024 and increment the date */
				}else
				{	
					count = 1024;
					fromDate = newFromDate;
				}
				 
					
				System.out.printf("Next date %s requestCount = %d actual count = %d\n", 
						DateFormat.getDateTimeInstance(
						DateFormat.FULL, DateFormat.FULL).format(fromDate),
						count,
						objectList.getCount());
			}
			
			
		}catch (InvalidRequest e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch (InvalidToken e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch (NotAuthorized e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch (NotImplemented e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch (ServiceFailure e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
